if not modules then modules = { } end modules ['t-simplefonts'] = {
    version   = 1.000,
    comment   = "Simplefonts",
    author    = "Wolfgang Schuster",
    copyright = "Wolfgang Schuster",
    email     = "schuster.wolfgang@googlemail.com",
    license   = "Public Domain"
}

local texsprint, ctxcatcodes, prtcatcodes, format, lower, gsub, find = tex.sprint, tex.ctxcatcodes, tex.prtcatcodes, string.format, string.lower, string.gsub, string.find

thirddata             = thirddata             or { }
thirddata.simplefonts = thirddata.simplefonts or { }

local simplefonts = thirddata.simplefonts 

simplefonts.fontlist   = simplefonts.fontlist   or { }
simplefonts.extlist    = simplefonts.extlist    or { }
simplefonts.parameters = simplefonts.parameters or { }
simplefonts.features   = simplefonts.features   or { }

simplefonts.fontlist = {
    ["hiraginokakugothicpro"] = -- Hiragino Kaku Gothic Pro
        {
            ["normal"] =
                {
                    regular     = "hirakakuprow3" ,
                    italic      = "hirakakuprow3" ,
                    bold        = "hirakakuprow6" ,
                    bolditalic  = "hirakakuprow6" ,
                 } ,
        } ,
    ["hiraginokakugothicpron"] = -- Hiragino Kaku Gothic ProN
        {
            ["normal"] =
                {
                    regular     = "hirakakupronw3" ,
                    italic      = "hirakakupronw3" ,
                    bold        = "hirakakupronw6" ,
                    bolditalic  = "hirakakupronw6" ,
                } ,
        } ,
    ["hiraginokakugothicstd"] = -- Hiragino Kaku Gothic Std
        {
            ["normal"] =
                {
                    regular     = "hirakakustdw8" ,
                    italic      = "hirakakustdw8" ,
                    bold        = "hirakakustdw8" ,
                    bolditalic  = "hirakakustdw8" ,
                } ,
        } ,
    ["hiraginokakugothicstdn"] = -- Hiragino Kaku Gothic StdN
        {
            ["normal"] =
                {
                    regular     = "hirakakustdnw8" ,
                    italic      = "hirakakustdnw8" ,
                    bold        = "hirakakustdnw8" ,
                    bolditalic  = "hirakakustdnw8" ,
                } ,
        } ,
    ["hiraginomarugothicpro"] = -- Hiragino Maru Gothic Pro
        {
            ["normal"] =
                {
                    regular     = "hiramaruprow4" ,
                    italic      = "hiramaruprow4" ,
                    bold        = "hiramaruprow4" ,
                    bolditalic  = "hiramaruprow4" ,
                } ,
        } ,
    ["hiraginomarugothicpron"] = -- Hiragino Maru Gothic ProN
        {
            ["normal"] =
                {
                    regular     = "hiramarupronw4" ,
                    italic      = "hiramarupronw4" ,
                    bold        = "hiramarupronw4" ,
                    bolditalic  = "hiramarupronw4" ,
                } ,
        } ,
    ["hiraginominchopro"] = -- Hiragino Mincho Pro
        {
            ["normal"] =
                {
                    regular     = "hiraminprow3" ,
                    italic      = "hiraminprow3" ,
                    bold        = "hiraminprow6" ,
                    bolditalic  = "hiraminprow6" ,
                } ,
        } ,
    ["hiraginominchopron"] = -- Hiragino Mincho ProN
        {
            ["normal"] =
                {
                    regular     = "hiraminpronw3" ,
                    italic      = "hiraminpronw3" ,
                    bold        = "hiraminpronw6" ,
                    bolditalic  = "hiraminpronw6" ,
                } ,
        } ,
    ["latinmodernmono"] = -- Latin Modern Mono
        {
            ["normal"] =
                {
                    regular     = "lmmono10regular"       ,
                    bold        = "lmmonolt10bold"        ,
                    italic      = "lmmono10italic"        ,
                    slanted     = "lmmono10italic"        ,
                    bolditalic  = "lmmonolt10boldoblique" ,
                    boldslanted = "lmmonolt10boldoblique" ,
                    caps        = "lmmonocaps10regular"   ,
                    slantedcaps = "lmmonocaps10oblique"   ,
                } ,
        } ,
    ["latinmodernroman"] = -- Latin Modern Roman
        {
            ["normal"] =
                {
                    regular     = "lmroman10regular"      ,
                    bold        = "lmroman10bold"         ,
                    italic      = "lmroman10italic"       ,
                    slanted     = "lmromanslant10regular" ,
                    bolditalic  = "lmroman10bolditalic"   ,
                    boldslanted = "lmromanslant10bold"    ,
                    caps        = "lmromancaps10regular"  ,
                    slantedcaps = "lmromancaps10oblique"  ,
                } ,
        } ,
    ["latinmodernsans"] = -- Latin Modern Sans
        {
            ["normal"] =
                {
                    regular     = "lmsans10regular"     ,
                    bold        = "lmsans10bold"        ,
                    italic      = "lmsans10oblique"     ,
                    slanted     = "lmsans10oblique"     ,
                    bolditalic  = "lmsans10boldoblique" ,
                    boldslanted = "lmsans10boldoblique" ,
                } ,
        } ,
}

--~ for k,v in next, global.fonts.otf.tables.features do
--~     v = lower(gsub(gsub(gsub(v,"#",""),"-","")," ",""))
--~     simplefonts.features[v] = lower(gsub(k," ",""))
--~ end

simplefonts.features = {
                     ['accessallalternates'] = 'aalt',
                          ['abovebaseforms'] = 'abvf',
                ['abovebasemarkpositioning'] = 'abvm',
                  ['abovebasesubstitutions'] = 'abvs',
                    ['alternativefractions'] = 'afrc',
                                 ['akhands'] = 'akhn',
                         ['belowbaseforms' ] = 'blwf',
                ['belowbasemarkpositioning'] = 'blwm',
                  ['belowbasesubstitutions'] = 'blws',
              ['petitecapitalsfromcapitals'] = 'c2pc',
               ['smallcapitalsfromcapitals'] = 'c2sc',
                    ['contextualalternates'] = 'calt',
                      ['casesensitiveforms'] = 'case',
           ['glyphcompositiondecomposition'] = 'ccmp',
                           ['conjunctforms'] = 'cjct',
                     ['contextualligatures'] = 'clig',
                          ['capitalspacing'] = 'cpsp',
                         ['contextualswash'] = 'cswh',
                      ['cursivepositioning'] = 'curs',
                       ['defaultprocessing'] = 'dflt',
                               ['distances'] = 'dist',
                  ['discretionaryligatures'] = 'dlig',
                            ['denominators'] = 'dnom',
                            ['dotlessforms'] = 'dtls',
                             ['expertforms'] = 'expt',
                    ['finalglyphalternates'] = 'falt',
                          ['terminalforms2'] = 'fin2',
                          ['terminalforms3'] = 'fin3',
                           ['terminalforms'] = 'fina',
            ['flattenedaccentsovercapitals'] = 'flac',
                               ['fractions'] = 'frac',
                               ['fullwidth'] = 'fwid',
                               ['halfforms'] = 'half',
                             ['halantforms'] = 'haln',
                      ['alternatehalfwidth'] = 'halt',
                         ['historicalforms'] = 'hist',
                ['horizontalkanaalternates'] = 'hkna',
                     ['historicalligatures'] = 'hlig',
                                  ['hangul'] = 'hngl',
                          ['hojokanjiforms'] = 'hojo',
                               ['halfwidth'] = 'hwid',
                            ['initialforms'] = 'init',
                           ['isolatedforms'] = 'isol',
                                 ['italics'] = 'ital',
               ['justificationalternatives'] = 'jalt',
                            ['jis2004forms'] = 'jp04',
                              ['jis78forms'] = 'jp78',
                              ['jis83forms'] = 'jp83',
                              ['jis90forms'] = 'jp90',
                                 ['kerning'] = 'kern',
                              ['leftbounds'] = 'lfbd',
                       ['standardligatures'] = 'liga',
                        ['leadingjamoforms'] = 'ljmo',
                           ['liningfigures'] = 'lnum',
                          ['localizedforms'] = 'locl',
                         ['markpositioning'] = 'mark',
                            ['medialforms2'] = 'med2',
                             ['medialforms'] = 'medi',
                       ['mathematicalgreek'] = 'mgrk',
                   ['marktomarkpositioning'] = 'mkmk',
          ['markpositioningviasubstitution'] = 'mset',
                ['alternateannotationforms'] = 'nalt',
                           ['nlckanjiforms'] = 'nlck',
                              ['nuktaforms'] = 'nukt',
                              ['numerators'] = 'numr',
                         ['oldstylefigures'] = 'onum',
                           ['opticalbounds'] = 'opbd',
                                ['ordinals'] = 'ordn',
                               ['ornaments'] = 'ornm',
              ['proportionalalternatewidth'] = 'palt',
                          ['petitecapitals'] = 'pcap',
                     ['proportionalfigures'] = 'pnum',
                            ['prebaseforms'] = 'pref',
                    ['prebasesubstitutions'] = 'pres',
                           ['postbaseforms'] = 'pstf',
                   ['postbasesubstitutions'] = 'psts',
                      ['proportionalwidths'] = 'pwid',
                           ['quarterwidths'] = 'qwid',
                               ['randomize'] = 'rand',
                              ['rakarforms'] = 'rkrf',
                       ['requiredligatures'] = 'rlig',
                                ['rephform'] = 'rphf',
                             ['rightbounds'] = 'rtbd',
                   ['righttoleftalternates'] = 'rtla',
                       ['rubynotationforms'] = 'ruby',
                     ['stylisticalternates'] = 'salt',
                     ['scientificinferiors'] = 'sinf',
                             ['opticalsize'] = 'size',
                           ['smallcapitals'] = 'smcp',
                         ['simplifiedforms'] = 'smpl',
                           ['stylisticset1'] = 'ss01',
                           ['stylisticset2'] = 'ss02',
                           ['stylisticset3'] = 'ss03',
                           ['stylisticset4'] = 'ss04',
                           ['stylisticset5'] = 'ss05',
                           ['stylisticset6'] = 'ss06',
                           ['stylisticset7'] = 'ss07',
                           ['stylisticset8'] = 'ss08',
                           ['stylisticset9'] = 'ss09',
                          ['stylisticset10'] = 'ss10',
                          ['stylisticset11'] = 'ss11',
                          ['stylisticset12'] = 'ss12',
                          ['stylisticset13'] = 'ss13',
                          ['stylisticset14'] = 'ss14',
                          ['stylisticset15'] = 'ss15',
                          ['stylisticset16'] = 'ss16',
                          ['stylisticset17'] = 'ss17',
                          ['stylisticset18'] = 'ss18',
                          ['stylisticset19'] = 'ss19',
                          ['stylisticset20'] = 'ss20',
                             ['scriptstyle'] = 'ssty',
                               ['subscript'] = 'subs',
                             ['superscript'] = 'sups',
                                   ['swash'] = 'swsh',
                                 ['titling'] = 'titl',
                       ['trailingjamoforms'] = 'tjmo',
                    ['traditionalnameforms'] = 'tnam',
                          ['tabularfigures'] = 'tnum',
                        ['traditionalforms'] = 'trad',
                             ['thirdeidths'] = 'twid',
                                 ['unicase'] = 'unic',
                ['alternateverticalmetrics'] = 'valt',
                           ['vattuvariants'] = 'vatu',
                         ['verticalwriting'] = 'vert',
            ['alternateverticalhalfmetrics'] = 'vhal',
                          ['voweljamoforms'] = 'vjmo',
                  ['verticalkanaalternates'] = 'vkna',
                         ['verticalkerning'] = 'vkrn',
    ['proportionalalternateverticalmetrics'] = 'vpal',
                        ['verticalrotation'] = 'vrt2',
                             ['slashedzero'] = 'zero',
                    -- context only features
              ['traditionaltexreplacements'] = 'trep',
                 ['traditionaltexligatures'] = 'tlig',
}

function simplefonts.selectfont(font,name,extension,style,weight)
    local fontname = {}
    local name     = lower(gsub(gsub(name," ",""),"-",""))
    if extension ~= "" then
        ext = find(extension,"*")
        if ext ~= nil then
            fontname = gsub(extension,"*",name)
        else
            fontname = extension
        end
        fontname = "name:" .. lower(gsub(fontname," ",""))
    else
        if simplefonts.fontlist[name] then
            if simplefonts.fontlist[name][weight] then
                if simplefonts.fontlist[name][weight][style] then
                    fontname = simplefonts.fontlist[name][weight][style]
                else
                    fontname = simplefonts.fontlist[name][weight]["regular"]
                end
            elseif simplefonts.fontlist[name]["normal"] then
                if simplefonts.fontlist[name]["normal"][style] then
                    fontname = simplefonts.fontlist[name]["normal"][style]
                else
                    fontname = simplefonts.fontlist[name]["normal"]["regular"]
                end
            end
            fontname = "name:" .. fontname
        else
            -- use comma list
            for _, v in ipairs(simplefonts.extlist[weight][style]) do
                fontname = name .. v
                if global.fonts.names.exists(fontname) then
                    fontname = "name:" .. fontname
                    break
                else
                    --~ texsprint(prtcatcodes,format("\\showmessage\\m!simplefonts{1}{%s}",fontname))
                    fontname = "DefaultFont" -- no font is found
                end
            end
        end
    end
    --~ print(fontname)
    if fontname == "DefaultFont" then
        texsprint(prtcatcodes,format("\\showmessage\\m!simplefonts{1}{%s}",name))
    end
    texsprint(prtcatcodes,format("\\setvalue{\\????sf %s%s}{%s}",font,style,fontname))
end

function simplefonts.normalizefontname(name)
    local fontname = lower(gsub(gsub(name," ",""),"-","")) -- remove spaces and hyphens from the user specified name
    texsprint(ctxcatcodes,fontname)
end

function simplefonts.parameter(key,value,list)
    local features   = simplefonts.features[key]
    local parameters = simplefonts.parameters[key]
    if features then
        texsprint(format("\\addvalue{%s}{%s=%s}",list,features,value))
        --~ print(features .. "=" .. value)
    else
        if not parameters then
            texsprint(prtcatcodes,format("\\showmessage\\m!simplefonts{2}{%s}",key))
        end
    end
end
